library/urls.py
from django.urls import path
from django.conf.urls import url
from library.views import MainPageView, BooksPageView, BookChangeModal, GenresPageView, GenreChangeModal, \
    LocationsPageView, LocationChangeModal, SubscriptionsPageView, SubscriptionChangeModal, \
    BookMovementPageView, BookMovementChangeModal

urlpatterns = [
    path('', MainPageView.as_view(), name='main_page'),
    path('books/', BooksPageView.as_view(), name='books'),
    path('genres/', GenresPageView.as_view(), name='genres'),
    path('locations/', LocationsPageView.as_view(), name='locations'),
    path('subscriptions/', SubscriptionsPageView.as_view(), name='subscriptions'),
    path('book_movement/', BookMovementPageView.as_view(), name='book_movement'),

    url(r'^ajax_book_change_modal/$', BookChangeModal.as_view(), name='ajax_book_change_modal'),
    url(r'^ajax_genre_change_modal/$', GenreChangeModal.as_view(), name='ajax_genre_change_modal'),
    url(r'^ajax_location_change_modal/$', LocationChangeModal.as_view(), name='ajax_location_change_modal'),
    url(r'^ajax_subscription_change_modal/$', SubscriptionChangeModal.as_view(), name='ajax_subscription_change_modal'),
    url(r'^ajax_book_movement_change_modal/$', BookMovementChangeModal.as_view(), name='ajax_book_movement_change_modal'),
]

library_test_project/urls.py
from django.contrib import admin
from django.urls import path
from django.conf.urls import include
from django.contrib.staticfiles.urls import staticfiles_urlpatterns


urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include(('library.urls', 'library'), namespace='library')),
]


urlpatterns += staticfiles_urlpatterns()

library/models.py
from django.db import models


class Genre(models.Model):
    name = models.CharField(max_length=64, unique=True)


class Location(models.Model):
    room = models.PositiveIntegerField()
    shelving = models.PositiveIntegerField()
    shelf = models.PositiveIntegerField()

    class Meta():
        unique_together = ('room', 'shelving', 'shelf')


class Book(models.Model):
    name = models.CharField(max_length=128)
    author = models.CharField(max_length=128)
    publication_year = models.PositiveIntegerField()
    genre = models.ForeignKey(Genre, on_delete=models.CASCADE, related_name='genre')
    location = models.ForeignKey(Location, on_delete=models.CASCADE, related_name='location')


class Subscription(models.Model):
    full_name = models.CharField(max_length=128)
    birth_date = models.DateField()
    address = models.CharField(max_length=256)
    phone_number = models.CharField(max_length=16)


class BookMovement(models.Model):
    BOOK_REQUEST_GETTING = 1
    BOOK_REQUEST_RETURN = 2

    BOOK_REQUEST_CHOICES = (
        (BOOK_REQUEST_GETTING, 'Book getting'),
        (BOOK_REQUEST_RETURN, 'Book return'),
    )

    BOOK_RETURN_STATUS_EXCELLENT = 1
    BOOK_RETURN_STATUS_GOOD = 2
    BOOK_RETURN_STATUS_FAIR = 3
    BOOK_RETURN_STATUS_POOR = 4

    BOOK_RETURN_STATUS_CHOICES = (
        (BOOK_RETURN_STATUS_EXCELLENT, 'Excellent'),
        (BOOK_RETURN_STATUS_GOOD, 'Good'),
        (BOOK_RETURN_STATUS_FAIR, 'Fair'),
        (BOOK_RETURN_STATUS_POOR, 'Poor'),
    )

    book = models.ForeignKey(Book, on_delete=models.CASCADE, related_name='book')
    subscription = models.ForeignKey(Subscription, on_delete=models.CharField, related_name='subscription')
    date_getting = models.DateField()
    date_return = models.DateField()
    book_return_status = models.IntegerField(choices=BOOK_RETURN_STATUS_CHOICES, default=BOOK_RETURN_STATUS_GOOD)
    book_request = models.IntegerField(choices=BOOK_REQUEST_CHOICES, default=BOOK_REQUEST_GETTING)

library/forms.py
from django.forms import ModelForm

from library.models import Book, Genre, Location, Subscription, BookMovement


class BookForm(ModelForm):
    class Meta:
        model = Book
        fields = ['name', 'author', 'publication_year', 'genre', 'location']

    def clean(self):
        form_data = self.cleaned_data
        return form_data


class GenreForm(ModelForm):
    class Meta:
        model = Genre
        fields = ['name']

    def clean(self):
        form_data = self.cleaned_data
        return form_data


class LocationForm(ModelForm):
    class Meta:
        model = Location
        fields = ['room', 'shelving', 'shelf']

    def clean(self):
        form_data = self.cleaned_data
        return form_data


class SubscriptionForm(ModelForm):
    class Meta:
        model = Subscription
        fields = ['full_name', 'birth_date', 'address', 'phone_number']

    def clean(self):
        form_data = self.cleaned_data
        return form_data


class BookMovementForm(ModelForm):
    class Meta:
        model = BookMovement
        fields = ['book', 'subscription', 'date_getting', 'date_return', 'book_return_status', 'book_request']

    def clean(self):
        form_data = self.cleaned_data
        return form_data

library/views.py
import json

from datetime import datetime

from django.shortcuts import render
from django.views.generic import View
from django.http import HttpResponse, JsonResponse, QueryDict

from library.models import Book, Genre, Location, Subscription, BookMovement
from library.forms import BookForm, GenreForm, LocationForm, SubscriptionForm, BookMovementForm

class MainPageView(View):
    """ Show Main Page (index.html) """

    template_name = 'index.html'

    def get(self, request, *args, **kwargs):
        book_requests = dict(BookMovement.BOOK_REQUEST_CHOICES)
        statistics_by_dates = [
            {
                'date': book_movement.date_getting if book_movement.book_request == BookMovement.BOOK_REQUEST_GETTING
                                                   else book_movement.date_return,
                'book': '{} - {}'.format(book_movement.book.author, book_movement.book.name),
                'subscription': book_movement.subscription.full_name,
                'request': book_requests.get(book_movement.book_request, BookMovement.BOOK_REQUEST_GETTING)
            }
            for book_movement in BookMovement.objects.all()
        ]
        statistics_by_dates.sort(key=lambda k: k['date'], reverse=True)

        expired_subscriptions = []

        for item in BookMovement.objects.filter(book_request=BookMovement.BOOK_REQUEST_GETTING):
            expired_days = (datetime.now().date() - item.date_return).days
            if expired_days > 0:
                return_condition = False
                return_items = BookMovement.objects.filter(book=item.book, subscription=item.subscription,
                                                           book_request=BookMovement.BOOK_REQUEST_RETURN)
                if return_items:
                    for return_item in return_items:
                        if return_item.date_return > item.date_getting:
                            return_condition = True

                if not return_condition:
                    expired_subscriptions.append(
                        {
                            'subscription': item.subscription.full_name,
                            'book': '{} - {}'.format(item.book.author, item.book.name),
                            'date_return': item.date_return,
                            'expired_days': expired_days
                        }
                    )

        return render(request, self.template_name, {'statistics_by_dates': statistics_by_dates,
                                                    'expired_subscriptions': expired_subscriptions})


class BooksPageView(View):
    """ Show Books Page (books.html) """

    template_name = 'books.html'

    def get(self, request, *args, **kwargs):
        books = []
        for book in Book.objects.all():
            books.append({
                'id': book.id,
                'name': book.name,
                'author': book.author,
                'publication_year': book.publication_year,
                'genre': book.genre.name,
                'location': 'Room: {}. Shelving: {}. Shelf: {}'.format(book.location.room, book.location.shelving,
                                                                       book.location.shelf),
            })

        return render(request, self.template_name, {'books': books})


class BookChangeModal(View):
    def get(self, request, *args, **kwargs):
        book_id = request.GET.get('book_id', None)
        genres = dict((genre.id, genre.name) for genre in Genre.objects.all())
        location_template = 'Room - {}, Shelving - {}, Shelf - {}'
        locations = dict((location.id, location_template.format(location.room, location.shelving, location.shelf))
                                       for location in Location.objects.all())
        ajax_response = {
            'data': {},
            'genres': genres,
            'locations': locations,
            'location_name': ''
        }

        try:
            if book_id:
                book = Book.objects.get(pk=book_id)
                form = BookForm(instance=book)
                ajax_response['data'] = dict(form.initial)
                ajax_response['location_name'] = location_template.format(book.location.room, book.location.shelving,
                                                                   book.location.shelf)
        except:
            pass

        return HttpResponse(json.dumps(ajax_response), content_type='application/json')

    def post(self, request, *args, **kwargs):
        if request.is_ajax:
            valid = False
            book_id = request.POST.get('book_id', None)
            if book_id:
                book = Book.objects.get(pk=book_id)
                form = BookForm(request.POST, instance=book)
                if form.is_valid():
                    form.save()
                    valid = True
            else:
                form = BookForm(request.POST)
                if form.is_valid():
                    book = form.save(commit=False)
                    book.save()
                    valid = True

            if valid:
                return HttpResponse(json.dumps({'success': True}), content_type='application/json')
            else:
                return HttpResponse(json.dumps({'success': False,
                                                'errors': [(k, v[0]) for k, v in form.errors.items()]}),
                                    content_type='application/json')
        else:
            return HttpResponse(json.dumps({'success': False}), content_type='application/json')

    def delete(self, request, *args, **kwargs):
        try:
            book_id = QueryDict(request.body).get('book_id', None)
            if book_id:
                book = Book.objects.get(pk=book_id)
                book.delete()
            return HttpResponse(json.dumps({'success': True}), content_type='application/json')

        except Exception:
            return HttpResponse(json.dumps({'success': False}), content_type='application/json')


class GenresPageView(View):
    """ Show Genres Page (genres.html) """

    template_name = 'genres.html'

    def get(self, request, *args, **kwargs):
        genres = []
        for genre in Genre.objects.all():
            genres.append({
                'id': genre.id,
                'name': genre.name,
            })

        return render(request, self.template_name, {'genres': genres})


class GenreChangeModal(View):
    def get(self, request, *args, **kwargs):
        genre_id = request.GET.get('genre_id', None)
        ajax_response = {}

        try:
            if genre_id:
                genre = Genre.objects.get(pk=genre_id)
                ajax_response = {
                    'genre_id': genre_id,
                    'genre_name': genre.name,
                }
        except:
            pass

        return HttpResponse(json.dumps(ajax_response), content_type='application/json')

    def post(self, request, *args, **kwargs):
        if request.is_ajax:
            valid = False
            genre_id = request.POST.get('genre_id', None)
            if genre_id:
                genre = Genre.objects.get(pk=genre_id)
                form = GenreForm(request.POST, instance=genre)
                if form.is_valid():
                    form.save()
                    valid = True
            else:
                form = GenreForm(request.POST)
                if form.is_valid():
                    genre = form.save(commit=False)
                    genre.save()
                    valid = True
            if valid:
                return HttpResponse(json.dumps({'success': True}), content_type='application/json')
            else:
                return HttpResponse(json.dumps({'success': False,
                                                'errors': [(k, v[0]) for k, v in form.errors.items()]}),
                                    content_type='application/json')
        else:
            return HttpResponse(json.dumps({'success': False}), content_type='application/json')

    def delete(self, request, *args, **kwargs):
        try:
            genre_id = QueryDict(request.body).get('genre_id', None)
            if genre_id:
                genre = Genre.objects.get(pk=genre_id)
                genre.delete()
            return HttpResponse(json.dumps({'success': True}), content_type='application/json')

        except Exception:
            return HttpResponse(json.dumps({'success': False}), content_type='application/json')


class LocationsPageView(View):
    """ Show Locations Page (locations.html) """

    template_name = 'locations.html'

    def get(self, request, *args, **kwargs):
        locations = []
        for location in Location.objects.all():
            locations.append({
                'id': location.id,
                'room': location.room,
                'shelving': location.shelving,
                'shelf': location.shelf,
            })

        return render(request, self.template_name, {'locations': locations})


class LocationChangeModal(View):
    def get(self, request, *args, **kwargs):
        location_id = request.GET.get('location_id', None)
        ajax_response = {}

        try:
            if location_id:
                location = Location.objects.get(pk=location_id)
                ajax_response = {
                    'location_id': location_id,
                    'location_room': location.room,
                    'location_shelving': location.shelving,
                    'location_shelf': location.shelf,
                }
        except:
            pass

        return HttpResponse(json.dumps(ajax_response), content_type='application/json')

    def post(self, request, *args, **kwargs):
        if request.is_ajax:
            valid = False
            location_id = request.POST.get('location_id', None)
            if location_id:
                location = Location.objects.get(pk=location_id)

library/templates/base.html
{% extends 'adminlte/base.html' %}

{% load staticfiles %}

{% block title %}Library Test Project{% endblock %}


{% block stylesheets %}
    {% include 'styles.html' %}
{% endblock %}


{% block body_class %}fixed{% endblock %}


{% block content_header %}{% endblock %}


{% block content %}{% endblock %}


{% block nav_header %}
    {% include 'main_header.html' %}
{% endblock %}


{% block nav_sidebar %}
    {% include 'sidebar_menu.html' %}
{% endblock %}


{% block javascript %}
    {% include 'scripts.html' %}
{% endblock %}


{% block nav_footer %}
    {% include 'main_footer.html' %}
{% endblock %}

library/templates/book_movement.html
{% extends "base.html" %}

{% load staticfiles %}

{% block title %}Book Movement{% endblock %}

{% block content %}

    <div class="box box-primary">
        <div class="box-header with-border">
            <h3 class="box-title">
                Book Movement
            </h3>
        </div>

        <div class="box-body">
            <div class="form-group">
                <div class="col-sm-10 col-sm-offset-1">
                    <div class="table-responsive">
                        <table class="table table-hover" width="100%">
                            <thead class="bg-green-gradient">
                                <tr>
                                    <td width="5%" align="center">№</td>
                                    <td>Book</td>
                                    <td>Subscription</td>
                                    <td>Date Getting</td>
                                    <td>Date Return</td>
                                    <td>Return Status</td>
                                    <td>Request</td>
                                    <td width="7%" align="center">Edit</td>
                                    <td width="7%" align="center">Delete</td>
                                </tr>
                            </thead>
                            <tbody>
                                {% for book_movement in book_movements %}
                                    <tr>
                                        <td align="center">{{ forloop.counter }}</td>
                                        <td>{{ book_movement.book }}</td>
                                        <td>{{ book_movement.subscription }}</td>
                                        <td>{{ book_movement.date_getting }}</td>
                                        <td>{{ book_movement.date_return }}</td>
                                        <td>{{ book_movement.book_return_status}}</td>
                                        <td>{{ book_movement.book_request}}</td>
                                        <td align="center">
                                            <button type="button"
                                                    class="btn btn-primary btn-sm edit_modal"
                                                    data-toggle="modal"
                                                    data-book-movement-id="{{ book_movement.id }}"
                                                    data-target="#book_movements_modal">
                                                <i class="fa fa-edit"></i>
                                            </button>
                                        </td>
                                        <td align="center">
                                            <button type="button"
                                                    class="btn btn-danger btn-sm delete_book_movement"
                                                    data-book-movement-id="{{ book_movement.id }}">
                                                <i class="fa fa-trash"></i>
                                            </button>
                                        </td>
                                    </tr>
                                {% endfor %}
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>

        <div class="box-footer clearfix">
            <div class="col-sm-6 col-sm-offset-5">
                <button type="button" class="btn btn-danger pull-right"
                    data-toggle="modal"
                    data-book-movement-id="null"
                    data-target="#book_movements_modal">Add book movement
                </button>
            </div>
        </div>
    </div>

    <div id="book_movements_modal" class="modal fade" role="dialog">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                    <h4 class="modal-title">Book Movement</h4>
                </div>

                <div class="modal-body">
                    <form class="form-horizontal" id="form_book_movement"> {% csrf_token %}
                        <div class="form-group" hidden>
                            <label for="book_movement_id" class="col-sm-3 control-label">ID</label>
                            <div class="col-sm-7" id="book_movement_id_div">
                                <input id="book_movement_id" class="form-control" type="text" value="" readonly>
                                <span class="help-block" id="book_movement_id_help"></span>
                            </div>
                        </div>

                        <div class="form-group">
                            <label for="book" class="col-sm-3 control-label">Book</label>
                            <div class="col-sm-7" id="book_div">
                                <select id="book" class="form-control" type="text" name="book"></select>
                                <span class="help-block" id="book_help"></span>
                            </div>
                        </div>

                        <div class="form-group">
                            <label for="subscription" class="col-sm-3 control-label">Subscription</label>
                            <div class="col-sm-7" id="subscription_div">
                                <select id="subscription" class="form-control" type="text" name="subscription"></select>
                                <span class="help-block" id="subscription_help"></span>
                            </div>
                        </div>

                        <div class="form-group">
                            <label for="date_getting" class="col-sm-3 control-label">Date Getting</label>
                            <div class="col-sm-7" id="date_getting_div">
                                <input id="date_getting" class="form-control" type="date" value="2019-01-01"
                                       style="padding-top: 0px">
                                <span class="help-block" id="date_getting_help"></span>
                            </div>
                        </div>

                        <div class="form-group">
                            <label for="date_return" class="col-sm-3 control-label">Date Return</label>
                            <div class="col-sm-7" id="date_return_div">
                                <input id="date_return" class="form-control" type="date" value="2019-01-01"
                                       style="padding-top: 0px">
                                <span class="help-block" id="date_return_help"></span>
                            </div>
                        </div>

                        <div class="form-group">
                            <label for="book_return_status" class="col-sm-3 control-label">Book return status</label>
                            <div class="col-sm-7" id="book_return_status_div">
                                <select id="book_return_status" class="form-control" type="text"
                                        name="book_return_status"></select>
                                <span class="help-block" id="book_return_status_help"></span>
                            </div>
                        </div>

                        <div class="form-group">
                            <label for="book_request" class="col-sm-3 control-label">Book request</label>
                            <div class="col-sm-7" id="book_request_div">
                                <select id="book_request" class="form-control" type="text" name="book_request"></select>
                                <span class="help-block" id="book_request_help"></span>
                            </div>
                        </div>
                    </form>
                </div>

                <div class="modal-footer">
                    <button type="button" class="btn btn-danger pull-left" id="delete_book_movement">Delete</button>
                    <button type="button" class="btn btn-warning pull-left" id="save_book_movement">Save</button>
                    <button type="button" class="btn btn-primary" data-dismiss="modal">Close</button>
                </div>
            </div>
        </div>
    </div>

{% endblock %}

{% block javascript %}
    {{ block.super }}

    <script type="text/javascript" src="{% static 'js/book_movement.js' %}"></script>
{% endblock %}

library/templates/expired_subscriptions.html
<div class="box-header with-border">
    <h3 class="box-title">
        Expired Subscriptions
    </h3>
</div>

<div class="box-body">
    <div class="form-group">
        <div class="col-sm-10 col-sm-offset-1">
            <div class="table-responsive">
                <table class="table table-hover" width="100%">
                    <thead class="bg-green-gradient">
                        <tr>
                            <td>Subscription</td>
                            <td>Book</td>
                            <td width="20%" align="center">Expected date return</td>
                            <td width="20%" align="center">Expired days</td>
                        </tr>
                    </thead>
                    <tbody>
                        {% for item in expired_subscriptions %}
                            <tr>
                                <td>{{ item.subscription }}</td>
                                <td>{{ item.book }}</td>
                                <td align="center">{{ item.date_return }}</td>
                                <td align="center">{{ item.expired_days }}</td>
                            </tr>
                        {% endfor %}
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</div>

<div class="box-footer clearfix">
</div>

library/templates/index.html
{% extends "base.html" %}

{% load staticfiles %}

{% block title %}Library Test Project{% endblock %}

{% block content %}

    <div class="box">
        <div class="box-header with-border">
            <h3 class="box-title">Library Test Project</h3>
        </div>

        <div class="box-body">
            <b>Python 3.6, Django 2.1.5, SQLite, HTML, jQuery, Bootstrap, AdminLTE</b>
        </div>

        <div class="box-footer clearfix">
            <a class="btn text-bold pull-left btn-primary bg-purple"
               href="https://gitlab.com/ivan.dibrova/library_test_project">
                <i class="fa fa-gitlab text-orange"></i>&nbsp;Link to GitLab Repository
            </a>
        </div>
    </div>

    <div class="box box-danger">
        {% include 'expired_subscriptions.html' %}
    </div>

    <div class="box box-primary">
        {% include 'statistics_by_dates.html' %}
    </div>

{% endblock %}

{% block javascript %}

    {{ block.super }}

{% endblock %}

library/templates/main_footer.html
<footer class="main-footer">

{#    <div class="pull-right hidden-xs">#}

        {% block footer_right %}
            <b>Version</b> {% block version %}1.0{% endblock %}
        {% endblock %}

{#    </div>#}

    {% block footer_left %}

        {% block legal %}
            <strong>Copyright &copy; {% now "Y" %}{% if not site %}.{% endif %}
                {% if site %}
                    <a href="http://{{ site.domain }}">{{ site.name }}</a>
                {% endif %}
            </strong> All rights reserved.
        {% endblock %}

    {% endblock %}

</footer>

library/templates/main_header.html
{% extends 'adminlte/lib/_main_header.html' %}


{% block logo %}

    <a href="{% block logo_href %}/{% endblock %}" class="logo">
        <span class="logo-mini">{% block logo_text_small %}<b>Lib</b>{% endblock %}</span>
        <span class="logo-lg">{% block logo_text %}<b>Library</b> Test Project{% endblock %}</span>
    </a>

{% endblock %}

library/templates/scripts.html
{% extends 'adminlte/lib/_scripts.html' %}

{% load staticfiles %}

{% block scripts %}
    {{ block.super }}

    <script src="https://cdnjs.cloudflare.com/ajax/libs/jQuery-slimScroll/1.3.8/jquery.slimscroll.min.js"></script>

    <script>
        let links = {
            ajax_book_change_modal: "{% url 'library:ajax_book_change_modal' %}",
            ajax_genre_change_modal: "{% url 'library:ajax_genre_change_modal' %}",
            ajax_location_change_modal: "{% url 'library:ajax_location_change_modal' %}",
            ajax_subscription_change_modal: "{% url 'library:ajax_subscription_change_modal' %}",
            ajax_book_movement_change_modal: "{% url 'library:ajax_book_movement_change_modal' %}",
        };

        function getCookie(name) {
            let cookieValue = null;
            if (document.cookie && document.cookie !== '') {
                let cookies = document.cookie.split(';');
                for (let i = 0; i < cookies.length; i++) {
                    let cookie = jQuery.trim(cookies[i]);
                    if (cookie.substring(0, name.length + 1) === (name + '=')) {
                        cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                        break;
                    }
                }
            }
            return cookieValue;
        }

        function csrfSafeMethod(method) {
            // these HTTP methods do not require CSRF protection
            return (/^(GET|HEAD|OPTIONS|TRACE)$/.test(method));
        }

    </script>

{% endblock %}

library/templates/sidebar_menu.html
{% extends 'adminlte/lib/_main_sidebar.html' %}

{% block user_panel %}{% endblock %}

{% block nav_links %}
    <!-- sidebar: style can be found in sidebar.less -->
    <section class="sidebar">
        <!-- Sidebar Menu -->
        <ul class="sidebar-menu">

            <li>
                <a href="{% url 'library:main_page' %}">
                    <i class="fa fa-building"></i><span>Main Page</span>
                </a>
            </li>

            <li>
                <a href="{% url 'library:books' %}">
                    <i class="fa fa-book"></i><span>Books</span>
                </a>
            </li>

            <li>
                <a href="{% url 'library:genres' %}">
                    <i class="fa fa-copy"></i><span>Genres</span>
                </a>
            </li>

            <li>
                <a href="{% url 'library:locations' %}">
                    <i class="fa fa-briefcase"></i><span>Locations</span>
                </a>
            </li>

            <li>
                <a href="{% url 'library:subscriptions' %}">
                    <i class="fa fa-file"></i><span>Subscriptions</span>
                </a>
            </li>

            <li>
                <a href="{% url 'library:book_movement' %}">
                    <i class="fa fa-truck"></i><span>Book Movement</span>
                </a>
            </li>

        </ul>
        <!-- /.sidebar-menu -->
    </section>
    <!-- /.sidebar -->
{% endblock nav_links %}

library/templates/styles.html
{% extends 'adminlte/lib/_styles.html' %}

{% load staticfiles %}

{% block styles %}

    {{ block.super }}

{% endblock %}